/*      Convert ASCII data file to WAV format
/*	   1/11/99
/*
/*	source: asc2wav.c
/*	link to mylib.obj using medium.bat (medium memory model)
/*	object: asc2wav.exe
/*
/*      Written for MIX PowerC compiler, ver 2.2.0 or later
/*
/*
*/
static char	vnr[14] = "v1.0-1/99";

#include <headers.h>

#define  CR   13
#define  BS   8
#define  LTM  62
#define  RTM  60
#define  EOS  '\0'
#define  xesc '\33'

static int	      ESC, i, j, k, m, n, ret, term;
static int	      flag8, size;
static unsigned int   value, v1, v2;
static unsigned long  count, x, y, jj, rate;
static char	      t1[60], t2[60], t3[60], temp[70], inbuf[30];
static char	      putcur[1] = '\0', NL[2] = '\12';
static char	      name1[20], name2[20], head[50], c[2];
double                a;
FILE                  *f1, *f2;

static char     CLRSCN[5] = {'\33','[','2','J','\0'};
static char     REVVID[5] = {'\33','[','7','m','\0'};
static char     ATTOFF[5] = {'\33','[','0','m','\0'};

void screen();
void get_count();
void make_hdr();
void process(); 
void formatl(char *, int);

main()
	{
	ESC = 0;
	screen();
	if (ESC == 9) goto m9;
        get_count();            /* count values in input file */
        make_hdr();		/* make WAV file header */
        process();		/* read ASCII data and write WAV */
m9:	exit(0);
	}

screen(void)
	{
        zcrtwr(0x0000, CLRSCN);
        zcrtwr(0x011A, "ASCII TO MONO WAV CONVERSION");
        zcrtwr(0x0140, vnr);
        zcrtwr(0x1519, "FREE NON-COMMERCIAL USE GRANTED");
     zcrtwr(0x1611, "TDL Technology, Inc., Las Cruces, NM 88012 USA");
        zcrtwr(0x1719, "505-382-3173, www.zianet.com/tdl");
        formatl("Input file name: ", 12);
        zcrtwr(0x0318, temp);
sc1:    zcrtwr2(0x032A, putcur);
        term = zcrtrd(13, 0x032A, inbuf);
        if (inbuf[0] == xesc) {ESC = 9; return;}
        for (n = 0; n < 12; n++)
           {
           name1[n] = toupper(inbuf[n]);
           }
        name1[14] = EOS;
        zcrtwr2(0x032A, name1);		/* display file name */
        f1 = fopen(name1, "r");
        if (f1 == 0) {zcrtwr2(0x032A, "            "); goto sc1;}
        zcrtwr(0x042A, "File open");
        
        strcpy(temp, "Output file will be named: ");
        for (n = 0; n <= 8; n++)
           {
           if (name1[n] == '.') break;
           }
        left(name1, name2, n);
        strcat(name2, ".WAV");
        strcat(temp, name2);
        zcrtwr(0x060E, temp);
        f2 = fopen(name2, "wb");
        if (f2 == 0) {zcrtwr(0x072A, "Can't open this file");
                      exit(0);}
        zcrtwr(0x072A, "File open");

        formatl("Sample rate: ", 5);
        zcrtwr(0x091C, temp);
        zcrtwr(0x0931, "Hz (4000 to 48000)");
sc2:    zcrtwr2(0x092A, putcur);
        term = zcrtrd(6, 0x092A, inbuf);
        if (inbuf[0] == xesc) {ESC = 9; return;}
        rate = atol(inbuf);
        if (rate >= 4000 && rate <= 48000) goto sc3;
        zcrtwr2(0x092A, "     ");
        goto sc2;

sc3:    formatl("Data size: ", 2);
        zcrtwr(0x0B1E, temp);
        zcrtwr(0x0B2E, "(8 or 16 bits)");
sc4:    zcrtwr2(0x0B2A, putcur);
        term = zcrtrd(3, 0x0B2A, inbuf);
        if (inbuf[0] == xesc) {ESC = 9; return;}
        size = atoi(inbuf);
        if (size == 8) {flag8 = 1; goto sc7;}
        if (size == 16) {flag8 = 0; goto sc7;}
        zcrtwr2(0x0B2A, "  ");
        goto sc4;
sc7:    return;
        }

get_count(void)		/* read first data file */
	{
        zcrtwr(0x0F14, "Counting input file...");
        count = 0;	/* count the number of data values */
get1:   fgets(t1, 20, f1);	/* read next number */
        if (feof(f1) != 0) goto get9;   /* end of file */
        count += 1;    /* count it */
        goto get1;
get9:   rewind(f1);     /* point to file start */
        ltoa(count, t1, 10);
        zcrtwr(0x0F14, "                        ");
        strcpy(temp, "Input file count: ");
        strcat(temp, t1);
        zcrtwr(0x0F14, temp);
	}

make_hdr(void)       /* make WAV file header */
        {
        head[0] = 'R';
        head[1] = 'I';
        head[2] = 'F';
        head[3] = 'F';
        if (flag8 == 1) {x = count + 36; goto hdr2;}
        x = (count * 2) + 36;         /* 16 bit data */
hdr2:   head[7] = (x >> 24) & 0xFF;    /* MSByte of length */
        head[6] = (x >> 16) & 0xFF;
        head[5] = (x >> 8) & 0xFF;
        head[4] = (x & 0xFF);         /* LSByte of length */
        head[8] = 'W';
        head[9] = 'A';
        head[10] = 'V';
        head[11] = 'E';
        head[12] = 'f';
        head[13] = 'm';
        head[14] = 't';
        head[15] = ' ';
        head[16] = 0x10;
        head[17] = 0x00;
        head[18] = 0x00;
        head[19] = 0x00;
        head[20] = 0x01;     /* PCM format - 2 bytes */
        head[21] = 0x00;
        head[22] = 0x01;     /* mono - 2 bytes */
        head[23] = 0x00;
        head[24] = rate & 0xFF;          /* low byte of sample rate */
        head[25] = (rate >> 8) & 0xFF;   /* high byte */
hdr3:   head[26] = 0x00;
        head[27] = 0x00;
        head[28] = rate & 0xFF;        
        head[29] = (rate >> 8) & 0xFF;
hdr4:   if (flag8 == 1) head[30] = 0x00; else head[30] = 0x01;
        head[31] = 0x00;
        if (flag8 == 1) head[32] = 0x01; else head[32] = 0x02;
        head[33] = 0x00;
        if (flag8 == 1) head[34] = 0x08; else head[34] = 0x10;
        head[35] = 0x00;
        head[36] = 'd';
        head[37] = 'a';
        head[38] = 't';
        head[39] = 'a'; 
        if (flag8 == 1) {x = count; goto hdr5;} 
        x = count * 2;
hdr5:   head[43] = (x >> 24) & 0xFF;  /* MSByte of data length */
        head[42] = (x >> 16) & 0xFF;
        head[41] = (x >> 8) & 0xFF;
        head[40] = x & 0xFF;          /* LSByte of data length */
        }

process(void)     /* read ASCII file and write WAV file */
       {
       strcpy(temp, "Writing output value: ");
       zcrtwr(0x1010, temp);
       jj = 0;
       for (n = 0; n < 44; n++)
          {
          ret = fputc(head[n], f2);    /* write header */
          if (ret == -1) {zcrtwr(0x1210, "WAV file write error");
             exit(0);}
          }
pro1:  fgets(t1, 20, f1);    /* read next ASCII number */
       if (feof(f1) != 0) goto pro9;   /* end of file */
       a = atof(t1);         /* floating point number in a */
       if (flag8 == 0) goto pro5;

       if (a == -0.0 || a == 0.0) {value = 128; goto pro2;}
       if (a > 0.0) 
          {
          if (a > 1.0) a = 1.0;
          value = 128. + (a * 127.);
          goto pro2;
          }
       if (a < -1.0) a = -1.0;
       value = 128. + (a * 128.);
pro2:  ret = fputc(value, f2);
       if (ret == -1) {zcrtwr(0x1210, "Output file write error");
              exit(0);}
pro4:  jj += 1;
       ltoa(jj, t2, 10);
       zcrtwr(0x1026, t2);
       goto pro1;

pro5:  if (a == -0.0 || a == 0.0) {v1 = 0; v2 = 0; goto pro7;}
       if (a > 0.0) 
          {
          if (a > 1.0) a = 1.0;
          value = a * 32767.;
          goto pro6;
          }
       if (a < -1.0) a = -1.0;
       value = 65536. + (a * 32767.);
pro6:  v1 = (value >> 8) & 0xFF;
       v2 = value & 0xFF;
pro7:  ret = putc(v2, f2);
       if (ret == -1) {zcrtwr(0x1210, "Output file write error");
            exit(0);}
       ret = putc(v1, f2);
       if (ret == -1) {zcrtwr(0x1510, "Output file write error");
            exit(0);}
       goto pro4;

pro9:  fclose(f1);
       fclose(f2);
       }

formatl(char *bs, int b)	/* format data entry line */
	{
	int j, k;
	j = 0; k = 0;
	while (bs[k] != EOS)
	   {temp[j] = bs[k]; j++; k++;}
	k = 0;
	while (REVVID[k] != EOS)
	   {temp[j] = REVVID[k]; j++; k++;}
	temp[j] = LTM;
	j += 1;
	while (b > 0) {temp[j] = ' '; j++; b--;}
	temp[j] = RTM;
	j += 1;
	k = 0;
	while (ATTOFF[k] != EOS)
	   {temp[j] = ATTOFF[k]; j++; k++;}
	temp[j] = EOS;
	}
