/*      Normalize ASCII data file
/*	   1/16/99
/*
/*	source: normasci.c
/*	link to mylib.obj
/*	object: normasci.exe
/*
/*      Written for MIX PowerC compiler, ver 2.2.0 or later
/*
/*      Compile as medium memory model (use medium.bat)
/*
/*   ver 1.1-1/19/99, added bias removal option if pos peak to
/*     neg peak difference is greater than 10% of peak-to-peak.
/*   ver 1.2-1/23/99, decreased scaling factor so that peaks
/*     will be only about -.95 to +.95 volt. This is to keep
/*     from over driving the asc2wav program.
/*
*/
static char	vnr[14] = "v1.2-1/99";

#include <headers.h>

#define  CR   13
#define  BS   8
#define  LTM  62
#define  RTM  60
#define  EOS  '\0'
#define  xesc '\33'

static int	      ESC, i, kk, m, n, ret, term, bflag;
static unsigned int   j, k, c;
static unsigned long  count, jj, pcount, ncount;
static char	      t1[60], t2[60], t3[60], temp[70], inbuf[30];
static char           t4[60], t5[60];
static char	      putcur[1] = '\0', NL[2] = '\12';
static char	      name1[20], name2[20];
double                a, value, pospeak, negpeak, sfactor;
double                pkpk, diff, pdiff, bias;
FILE                  *f1, *f2;

static char     CLRSCN[5] = {'\33','[','2','J','\0'};
static char     REVVID[5] = {'\33','[','7','m','\0'};
static char     ATTOFF[5] = {'\33','[','0','m','\0'};

void screen();
void find_peak();
void process(); 
void formatl(char *, int);

main()
	{
	ESC = 0;
	screen();
	if (ESC == 9) goto m9;
        find_peak();    /* read file to find peak value */
        if (ESC == 9) goto m9;
        process();	/* read ASCII data and write new ASCII */
m9:	exit(0);
	}
screen(void)
	{
        zcrtwr(0x0000, CLRSCN);
        zcrtwr(0x011B, "NORMALIZE ASCII DATA FILE");
        zcrtwr(0x0140, vnr);
        zcrtwr(0x0216, "Scales values so peak is +.95 to -.95");
        zcrtwr(0x1519, "FREE NON-COMMERCIAL USE GRANTED");
    zcrtwr(0x1611, "TDL Technology, Inc., Las Cruces, NM 88012 USA");
        zcrtwr(0x1719, "505-382-3173, www.zianet.com/tdl");
        formatl("Input file name: ", 12);
        zcrtwr(0x0418, temp);
sc1:    zcrtwr2(0x042A, putcur);
        term = zcrtrd(13, 0x042A, inbuf);
        if (inbuf[0] == xesc) {ESC = 9; return;}
        for (n = 0; n < 12; n++)
           {
           name1[n] = toupper(inbuf[n]);
           }
        f1 = fopen(name1, "r");
        if (f1 == 0) {zcrtwr2(0x042A, "            "); goto sc1;}
        zcrtwr(0x052A, "File open");
        
        strcpy(temp, "Output file will be named: ");
        for (n = 0; n <= 8; n++)
           {
           if (name1[n] == '.') break;
           }
        left(name1, name2, n);
        strcat(name2, ".NEW");
        strcat(temp, name2);
        zcrtwr(0x070E, temp);
        f2 = fopen(name2, "w");
        if (f2 == 0) {zcrtwr(0x082A, "Can't open this file");
                      exit(0);}
        zcrtwr(0x082A, "File open");
        }

find_peak(void)	 /* read file to find peak value for scaling */     
	{
        zcrtwr(0x0A11, "Searching for peaks; count = ");
        bflag = 0;
        jj = 0;
        bias = 0.0;
        negpeak = 0.0;
        pospeak = 0.0;
pk1:    fgets(t1, 20, f1);
        if (feof(f1) != 0) goto pk7;   /* end of file */
        strcpy(t2, t1);     /* make a copy of t1 */
        for (n = 0; n <= 4; n++) {if (t2[n] == '.') break;}
        for (i = n + 1; i <= 15; i++)
           {
           c = t2[i];
           if (isdigit(c) == 0) break;
           }
        m = i - n - 1;
       /* m is number of digits after the decimal point */
        goto pk3;

pk2:    fgets(t1, 20, f1);
        if (feof(f1) != 0) goto pk7;
pk3:    value = atof(t1);	/* convert to double */
        if (value == 0.0) goto pk5;  /* skip if zero */
        if (value < 0.0) goto pk4;
        if (value > pospeak) {pospeak = value; pcount = jj; goto pk5;}
pk4:    if (value < negpeak) {negpeak = value; ncount = jj;}
pk5:    jj += 1;
        ltoa(jj, t2, 10);
        zcrtwr(0x0A2E, t2);
        goto pk2;
pk7:    fclose(f1);
        f1 = fopen(name1, "r");

        zcrtwr(0x0A10, "                                       ");
        zcrtwr(0x1105, t2);   /* search value count */
        strcpy(temp, "Positive peak = ");
        ftoa(pospeak, t1, 0, 1, m);
        strcat(temp, t1);
        strcat(temp, "   Location count = ");
        ltoa(pcount, t1, 10);
        strcat(temp, t1);
        zcrtwr(0x0A0E, temp);
        strcpy(temp, "Negative peak = ");
        ftoa(negpeak, t1, 0, 1, m);
        strcat(temp, t1);
        strcat(temp, "  Location count = ");
        ltoa(ncount, t1, 10);
        strcat(temp, t1);
        zcrtwr(0x0B0E, temp);

        diff = pospeak + negpeak;
        if (diff < 0.0) pdiff = diff * -1.0; /* pdiff is positive */
        pkpk = pospeak - negpeak;            /* peak to peak value */
        if (pdiff < (pkpk * 0.1)) goto pk15;

        formatl("Remove constant bias? ", 1);        
        zcrtwr(0x0D13, temp);
        zcrtwr(0x0D2D, "(Y or N)");
pk9:    zcrtwr2(0x0D2A, putcur);
        term = zcrtrd(2, 0x0D2A, inbuf);
        if (inbuf[0] == xesc) {ESC = 9; return;}
        if (inbuf[0] == 'N' || inbuf[0] == 'n') goto pk15;
        if (inbuf[0] == 'Y' || inbuf[0] == 'y') {bflag = 1; goto pk10;}
        zcrtwr2(0x0D2A, " ");
        goto pk9;
pk10:   bias = diff / 2.0;    /* this is a positive value */

pk15:   negpeak = (negpeak - bias) * -1.0;  /* make it a pos number */
        pospeak = pospeak - bias;
        if (negpeak > pospeak) {sfactor = (.95 / negpeak);
           goto pk19;}
        sfactor = .95 / pospeak;
pk19:   strcpy(temp, "Scaling factor = ");
        ftoa(sfactor, t1, 0, 1, m);
        strcat(temp, t1);
        if (bflag != 1) goto pk20;
        strcat(temp, "   Bias = ");
        ftoa(bias, t1, 0, 1, m);   
        strcat(temp, t1);
pk20:   zcrtwr(0x0F10, temp);        
        }

process(void)     /* read ASCII file and write new ASCII file */
       {
       jj = 0;         /* clear output record number counter */
       k = m + 3;      /* number of characters in each value */
       strcpy(temp, "Writing output value: ");
       zcrtwr(0x1110, temp);
pro1:  fgets(t1, 20, f1);   /* read next number */
       if (feof(f1) != 0) goto pro9;   /* end of file */
       a = atof(t1);
       value = (a - bias) * sfactor;
       ftoa(value, t1, 0, 1, m);       
       strcpy(t4, "          ");
       strcat(t4, t1);
       right(t4, t5, k);
       strcat(t5, NL);  
       for (n = 0; n < k + 1; n++)
          {
          ret = putc(t5[n], f2);
          if (ret == EOF) {zcrtwr(0x1210, "Output file write error");
            exit(0);}
          }
       jj += 1;
       ltoa(jj, t2, 10);
       zcrtwr(0x1126, t2);
       goto pro1;
       
pro9:  fclose(f1);
       fclose(f2);
       }

formatl(char *bs, int b)	/* format data entry line */
	{
	int j, k;
	j = 0; k = 0;
	while (bs[k] != EOS)
	   {temp[j] = bs[k]; j++; k++;}
	k = 0;
	while (REVVID[k] != EOS)
	   {temp[j] = REVVID[k]; j++; k++;}
	temp[j] = LTM;
	j += 1;
	while (b > 0) {temp[j] = ' '; j++; b--;}
	temp[j] = RTM;
	j += 1;
	k = 0;
	while (ATTOFF[k] != EOS)
	   {temp[j] = ATTOFF[k]; j++; k++;}
	temp[j] = EOS;
	}
