/*      Convert Mono WAV data file to ASCII format
/*	   1/13/99
/*
/*	source: wav2asc.c
/*	link to mylib.obj
/*	object: wav2asc.exe
/*
/*      Written for MIX PowerC compiler, ver 2.2.0 or later
/*
/*      Compile as medium memory model (use medium.bat)
/*
/*  ver 1.1-1/18/99: added displaying the sample rate from the WAV
/*     file header
/*  ver 1.2-9/24/01: fixed problem with getting data resolution
/*     from header
/*  ver 1.3-10/27/01: fixed another header problem
/*
*/
static char	vnr[14] = "v1.3-10/01";

#include <headers.h>

#define  CR   13
#define  BS   8
#define  LTM  62
#define  RTM  60
#define  EOS  '\0'
#define  xesc '\33'

static int	      ESC, i, kk, m, n, ret, term, flag8, bits;
static unsigned int   value, j, k, srate_l, srate_h, header[100];
static unsigned long  count, jj, rate;
static char	      t1[60], t2[60], t3[60], temp[70], inbuf[30];
static char           t4[60], t5[60];
static char	      putcur[1] = '\0', NL[2] = '\12';
static char	      name1[20], name2[20];
double                a;
FILE                  *f1, *f2;

static char     CLRSCN[5] = {'\33','[','2','J','\0'};
static char     REVVID[5] = {'\33','[','7','m','\0'};
static char     ATTOFF[5] = {'\33','[','0','m','\0'};

void screen();
void get_hdr();
void process(); 
void formatl(char *, int);

main()
	{
	ESC = 0;
	screen();
	if (ESC == 9) goto m9;
        get_hdr();		/* read WAV file header */
        process();		/* read WAV data and write ASCII */
m9:	exit(0);
	}
screen(void)
	{
        zcrtwr(0x0000, CLRSCN);
        zcrtwr(0x011A, "MONO WAV TO ASCII CONVERSION");
        zcrtwr(0x0140, vnr);
        zcrtwr(0x1519, "FREE NON-COMMERCIAL USE GRANTED");
    zcrtwr(0x1611, "TDL Technology, Inc., Las Cruces, NM 88012 USA");
        zcrtwr(0x1719, "505-382-3173, www.zianet.com/tdl");
        formatl("Input file name: ", 8);
        zcrtwr(0x0318, temp);
        zcrtwr(0x0333, ".WAV");
sc1:    zcrtwr2(0x032A, putcur);
        term = zcrtrd(9, 0x032A, inbuf);
        if (inbuf[0] == xesc) {ESC = 9; return;}
        for (n = 0; n < 8; n++)
           {
           name1[n] = toupper(inbuf[n]);
           }
        strcat(name1, ".WAV"); 
        f1 = fopen(name1, "rb");
        if (f1 == 0) {zcrtwr2(0x032A, "        "); goto sc1;}
        zcrtwr(0x042A, "File open");
        
        strcpy(temp, "Output file will be named: ");
        for (n = 0; n <= 8; n++)
           {
           if (name1[n] == '.') break;
           }
        left(name1, name2, n);
        strcat(name2, ".ASC");
        strcat(temp, name2);
        zcrtwr(0x060E, temp);
        f2 = fopen(name2, "w");
        if (f2 == 0) {zcrtwr(0x072A, "Can't open this file");
                      exit(0);}
        zcrtwr(0x072A, "File open");
        }

get_hdr(void)	/* read WAV file header */
	{
        strcpy(t5, "Probably not a WAV file");
        bits = 0;
        n = 0;
hdr0:   j = fgetc(f1);
        if (feof(f1) != 0) {fclose(f1); return;}
        header[n] = j;
        n += 1;
        if (n <= 96) goto hdr0;

        if (header[22] != 1) {zcrtwr(0x091A, "NOT A MONO WAV FILE");
           exit(0);}
        if (header[0] != 'R') {zcrtwr(0x0915, t5); exit(0);}
        if (header[34] == 0x08) flag8 = 1;
        if (header[34] == 0x10) flag8 = 0;
        j = header[24];
        srate_l = j;
        j = header[25];
        srate_h = j;
        rate = srate_h << 8;
        rate = rate + (srate_l & 0xFF);
        ltoa(rate, t1, 10);
        strcpy(temp, "Sampling rate = ");
        strcat(temp, t1);
        strcat(temp, " Hz,  ");
        if (flag8 == 1) strcpy(t2, "8 bit data");
           else (strcpy(t2, "16 bit data"));
        strcat(temp, t2);
        zcrtwr(0x0910, temp);
        if (header[36] == 'd') count = 44; else count = 96;
        rewind(f1);
        }

process(void)     /* read WAV file and write ASCII file */
       {
       jj = 0;         /* clear output record number counter */
       strcpy(temp, "Header bytes removed: ");
       ltoa(count, t1, 10);
       strcat(temp, t1);
       zcrtwr(0x0B10, temp);

   /* dummy reads to get rid of header */
       n = 0;
pro0:  j = fgetc(f1);
       if (feof(f1) != 0) goto pro9;
       n += 1;
       if (n < count) goto pro0;

       strcpy(temp, "Writing output value: ");
       zcrtwr(0x1010, temp);
pro1:  j = fgetc(f1);    /* read next WAV number */
       if (feof(f1) != 0) goto pro9;   /* end of file */
       if (flag8 == 1) goto pro2;      /* 8 bit data */
       k = fgetc(f1);    /* else get second half of 16 bit data */
       if (feof(f1) != 0) goto pro9;   /* end of file */
       goto pro5;

pro2:  if (j == 128) {a = .00000; goto pro3;}
       if (j > 128) {a = (j - 128.) / 127.; goto pro3;}
       a = -1.0 + (j / 128.);
pro3:  ftoa(a, t1, 0, 1, 5);
       strcpy(t4, "        ");
       strcat(t4, t1);
       right(t4, t5, 8);
       goto pro7;

pro5:  value = j + (k << 8);
       if (value == 0) {a = .00; goto pro6;}
       if (value > 0 && value < 32768)
            {a = value / 32767.; goto pro6;}
       a = ((65536. - value) / 32767.) * -1.0;
pro6:  ftoa(a, t1, 0, 1, 6);       
       strcpy(t4, "          ");
       strcat(t4, t1);
       right(t4, t5, 9);

pro7:  strcat(t5, NL);  
       if (flag8 == 1) kk = 9; else kk = 10;  /* # chars to write */
       for (n = 0; n < kk; n++)
          {
          ret = putc(t5[n], f2);
          if (ret == EOF) {zcrtwr(0x1210, "Output file write error");
            exit(0);}
          }
       jj += 1;
       ltoa(jj, t2, 10);
       zcrtwr(0x1026, t2);
       goto pro1;
       
pro9:  fclose(f1);
       fclose(f2);
       }

formatl(char *bs, int b)	/* format data entry line */
	{
	int j, k;
	j = 0; k = 0;
	while (bs[k] != EOS)
	   {temp[j] = bs[k]; j++; k++;}
	k = 0;
	while (REVVID[k] != EOS)
	   {temp[j] = REVVID[k]; j++; k++;}
	temp[j] = LTM;
	j += 1;
	while (b > 0) {temp[j] = ' '; j++; b--;}
	temp[j] = RTM;
	j += 1;
	k = 0;
	while (ATTOFF[k] != EOS)
	   {temp[j] = ATTOFF[k]; j++; k++;}
	temp[j] = EOS;
	}
